/*
** Module   :IDCOLL.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Sun  15/06/2003 Created
**
*/

#include <idcoll.h>
#include <string.h>
#include <vio.h>
#include <version.h>
#include <line.h>

IDColl::IDColl():SortedCollection(128, 128), LastPos(0), WasMatch(0)
{
    bDuplicates = 0;
}

int IDColl::Compare(Ptr p1, Ptr p2)
{
    return strcmp((char*)p1, (char*)p2);
}

int IDColl::NextID(Line* ln, int len)
{
    if(!ln || !len)
        return 0;

    char* p = 0;
    char* start = ln->str;

    if(WasMatch)
    {
        p = (char*)Get(LastPos);

        if(p && !memcmp(p, start, len)) //Still match
        {
            ++LastPos;

            p = (char*)Get(LastPos);

            if(p && !memcmp(p, start, len)) //Next one is acceptable
            {
                ln->set(p);
                return 1;
            }

            //Next one is not acceptable, end of list is reached, scan back

            while(--LastPos)
            {
                p = (char*)Get(LastPos);

                if(!p || memcmp(p, start, len))
                {
                    LastPos++;
                    p = (char*)Get(LastPos);
                    break;
                }
            }

            //return p;
            ln->set(p);
            return 1;
        }

        //No match, look for candidate

        WasMatch = 0;
    }

    Line tmp(ln, 0, len);

    LastPos = Look(tmp.str);

    p = (char*)Get(LastPos);

    if(!p || memcmp(p, start, len)) //Still no match
        return 0;

    while(--LastPos)    //Scan back
    {
        p = (char*)Get(LastPos);

        if(!p || memcmp(p, start, len))
        {
            LastPos++;
            p = (char*)Get(LastPos);
            break;
        }
    }

    WasMatch = 1;

    ln->set(p);
    return 1;
}

void IDColl::AddID(char* start, int len)
{
    unsigned pos;
    int rc;

    char* tmp = str_dup(start, len);

    pos = Look(tmp);

    if(pos < Count())
    {
        rc = Compare(tmp, Get(pos));

        if(rc)  //No match, add into list
            At(tmp, pos);
        else
            delete tmp;
    }
    else
        Add(tmp);
}

